#include <iostream>

using namespace std;

bool compara(const int a, const int b) {
  return a<b;
}

bool inverso(const int a, const int b) {
  return compara(b,a);
}

void swap(int &a, int &b) {
  int tmp = a;
  a = b;
  b = tmp;
}

void ordena(int array[], int tamano, bool (*f)(const int, const int)) {
  for (int i=1; i<tamano; i++) {
    for (int j=i; j>0; j--) {
      if (f(array[j],array[j-1])) {
        swap(array[j-1],array[j]);
      }
    }
  }
}

int main() {
  int array[] = {8,9,7,5,6,4};
  cout << "Orden normal:" << endl;
  ordena(array,6,compara);
  for (int i=0; i<6; i++) cout << array[i] << " "; cout << endl;
  cout << "Orden inverso:" << endl;
  ordena(array,6,inverso);
  for (int i=0; i<6; i++) cout << array[i] << " "; cout << endl;
}

